clear all

%read input data (POINTS)   
    P3 = load('coor.dat','-ascii');
    ROWP = length(P3);
  
%filter out unnecessary points
    H = 0;
    for I = 1:ROWP
        B = P3(I,4);
        if B == 1 || B == 2 || B==3 || B == 4 || B == 9 || B == 10 || B == 11 || B == 12 || B == 21;
            H = H+1;
            P4(H,:) = P3(I,:);
        else 
        end;
    end;
    PEND = P4;
    P3 = P4;
    ROWP = H;
    
%build trangles
    x = P3(:,1);
    y = P3(:,2);
    T4 = delaunay(x,y);
    H = length(T4);

%read input data (LATITUDE, DATE, TIME)
%for reasons of simplicity the maximum height is assumed to be at 12:00,
%time zones are neglected
    OK = 0;
    while OK == 0
        fprintf(1,'Escriba el grado de latitud\n');
        fprintf(1,'Por ejemplo: 28 (Gran Canaria)\n');
        PHI = input(' ');
        if PHI >= -90 && PHI <= 90
            OK = 1;
        else
            fprintf(1,'El grado de latitud debe ser un entero mayor que -90 y menor que 90.\n');
        end;
    end;
    OK = 0;
    while OK == 0
        fprintf(1,'Escriba la fecha in lineas seperadas. Por ejemplo:\n');   
        fprintf(1,'1 (=primero)\n'); 
        fprintf(1,'1 (=de enero)\n');
        DAY = input(' ');
        MONTH = input(' ');
        if DAY >= 1 && DAY <= 31 && MONTH >= 1 && MONTH <= 12
            OK = 1;
        else
            fprintf(1,'La fecha no esta correcta.\n');
        end;
    end;
    OK = 0;
    while OK == 0
        fprintf(1,'Escriba la hora. Por ejemplo 14 (=14:00) :\n'); 
        TIME = input(' ');
        if TIME >= 0 && TIME <= 24 
            OK = 1;
        else
            fprintf(1,'La hora debe ser un entero entre 0 y 24.\n');
        end;
    end;

    
%deklination of the sun 
    DAYOFYEAR=0;
    for i = 1:MONTH-1
        if i == 2 
            n = 28;
            elseif i == 4 || i == 6 || i == 9 || i == 11  
                 n = 30;
            else n = 31;
        end;
    DAYOFYEAR=DAYOFYEAR+n;
    end;
    DAYOFYEAR=DAYOFYEAR+DAY;
    ALPHA = 2*pi*(DAYOFYEAR+10)/365;
    deltamax = -23.43*pi/180;
    DELTA = asin(tan(deltamax)*cos(ALPHA));
  
% build transformation matrices

BETA = pi*(TIME-12)/12;
PHI = pi*PHI/180;
M1 = [1 0 0; 0 cos(PHI) -sin(PHI); 0  sin(PHI) cos(PHI)]; % around X
M2 = [cos(BETA) 0 -sin(BETA); 0 1 0; sin(BETA) 0  cos(BETA)]; % around Y'
M3 = [1 0 0; 0 cos(DELTA) sin(DELTA); 0  -sin(DELTA) cos(DELTA)]; % around X''

VSUN = M1*M2*M3*[0;0;1];

   if VSUN(3,1) > 0
       
%transform points
for I = 1:ROWP
    for L = 1:3;
    B1(L,1) = P3(I,L) ;
    end; 
    B2 = M3'*M2'*M1'*B1;
    B3 = B2';
    for N = 1:3
    P4(I,N) = B2(N,1);
    end;
end;      
P3 = P4;

%write point components into matrix
    T5 = zeros(H,4);
    for I = 1:H
        for J = 1:3 
            for L = 1:3;
                K =(J-1)*3+L;
                T5(I,K) = P3(T4(I,J),L);
            end;
        end;
    end;
    T6 = T5;       
 
   %calculate centers
        for I = 1:H    
            for L = 1:3;
                M = L+3;
                N = L+6;
                A(L,1) = T6(I,L);
                B(L,1) = T6(I,M);
                C(L,1) = T6(I,N);
            end;
            D = (B+C)/2;
            E = D-A;
            S = A+(2*E)/3;
            for O = 1:3;
                P = 10+O;
                T6(I,P) = S(O,1);
            end;
        end;

    %calculate gridunit
        for I = 1:H;
            for J = 1:3; 
                K = J*3-2; 
                L = K+1;
                D(I,J) = (T6(I,K)-T6(I,11))^2+(T6(I,L)-T6(I,12))^2;
            end;
         end;
         MAXD = max(D);
         MAXDT = MAXD';
         MAX = max(MAXDT);
         GU = sqrt(MAX);

    %asign grid position 
        for I = 1:H;
            GX = T6(I,11)/GU;
            GY = T6(I,12)/GU;
            T6(I,14) = ceil(GX);
            T6(I,15) = ceil(GY);
        end;

    %find out if triangle is in shadow(1) or not (0) 
        T7 = T6;
        for I = 1:H
            I

        %find possible candidates: a) (check GX)
            clear PC1
            M = 0;
            T6 = T7;
            T6(I,:) = [];
            T6(:,10) = 0;
            for J = 1:H-1;
                K = T7(I,14);
                if  T6(J,14) == K || T6(J,14) == K+1 || T6(J,14) == K-1 
                    M = M+1;
                    PC1(M,:) = T6(J,:);
                else 
                end;
            end; 

        %find possible candidates: b) (check GY)
            clear PC2
            N = 0; 
            for J = 1:M;
                K = T7(I,15);
                if  PC1(J,15) == K || PC1(J,15) == K+1 || PC1(J,15) == K-1 
                    N = N+1;
                    PC2(N,:) = PC1(J,:);
                else
                end;
            end; 
            PC2(:,14:15) = [];

        %find possible candidates: c) check distance 
            clear PC4
            CIX = T7(I,11); 
            CIY = T7(I,12); 
            L = 0;
            for J = 1:N
                CX = PC2(J,11); 
                CY = PC2(J,12);
                DC = (CIX-CX)^2+(CIY-CY)^2;
                    if  DC <= MAX+0.001;  %did not work correctly with MAX
                        L = L+1;
                        PC4(L,:) = PC2(J,:);
                        PC4(L,10) = DC;
                    else
                    end;
            end;

        %sort according to distance    
            PC4 = PC4(:,[10 2 3 4 5 6 7 8 9 1 11 12 13]);
            PC4 = sortrows(PC4);
            PC4 = PC4(:,[10 2 3 4 5 6 7 8 9 1 11 12 13]);

        %find possible candidates: d) prefer triangles with centre nearer to sun
            clear PC5
            clear PC6
            clear PC7
            P = 0;
            Q = 0;
            for J = 1:L
                K = T7(I,13);
                if  PC4(J,13) >= K
                    P = P+1;
                    PC6(P,:) = PC4(J,:);
                else Q = Q+1;
                    PC5(Q,:) = PC4(J,:);
                end;
            end;
            for J = 1:P;
                PC7(J,:) = PC6(J,:);
            end;
            for J = 1:Q; K = P+J;
                PC7(K,:) = PC5(J,:);
            end; 

        %check if shadow(1) or not (0)     
            a = 0;
            G = 0;
            while a == 0
                G = G + 1;
                if G == L + 1 
                    a = 1;
                else
                    P1X = PC7(G,1);
                    R12X = PC7(G,4)-P1X;
                    R13X = PC7(G,7)-P1X;
                    CIX = T7(I,11);
                    P1Y = PC7(G,2);
                    R12Y = PC7(G,5)-P1Y;
                    R13Y = PC7(G,8)-P1Y;
                    CIY = T7(I,12);
             %[x,y] = solve('P1X+x*R12X+y*R13X=CIX','P1Y+x*R12Y+y*R13Y=CIY')
             %(was not able to calculate the number...)
                    x = -(-P1Y*R13X+R13Y*P1X-R13Y*CIX+CIY*R13X)/(-R12Y*R13X+R12X*R13Y);
                    y = (R12Y*P1X+R12X*CIY-R12Y*CIX-R12X*P1Y)/(-R12Y*R13X+R12X*R13Y);
                    if x < 1 && x > 0 && y < 1 && y > 0 && (x+y) <= 1
                        P1Z = PC7(G,3);
                        R12Z = PC7(G,6)-P1Z;
                        R13Z = PC7(G,9)-P1Z;
                        CIZ = T7(I,13);
                        RZCZ = P1Z+x*R12Z+y*R13Z-CIZ;
                        if RZCZ > 0 
                            T7(I,10) = 1;
                            a = 1;
                        else
                        end;
                    else
                    end;
                end;
            end;
        end;

        T(:,10) = T7(:,10);
    else
        T(:,10) = 0;
    end;
    P3 = PEND;
    SHADOW = -T(:,10);
    trisurf(T4,P3(:,1),P3(:,2),P3(:,3),SHADOW);

    